#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-
# generated by wxGlade 0.6.5 on Fri Jun 27 16:30:47 2014

import wx
import easygui
# begin wxGlade: dependencies
import gettext
# end wxGlade

# begin wxGlade: extracode
from numpy import *
from numpy import max as npmax
from numpy import min as npmin
from matplotlib.pyplot import plot,figure,show,title,subplot,grid
import matplotlib
matplotlib.use('WXAgg')
from matplotlib.backends.backend_wxagg import FigureCanvasWxAgg as FigureCanvas
from matplotlib.backends.backend_wx import NavigationToolbar2Wx
from matplotlib.figure import Figure   # http://matplotlib.org/api/figure_api.html#module-matplotlib.figure
# end wxGlade

#==== Global Functions ================================================
#== Learning Entropy (AISLE) =======
def fcnEA(Wm,alphas,OLEs): #Wm ... recent window of weights including the very last weight updates
    OLEs=OLEs.reshape(-1)
    nw=Wm.shape[1]
    nalpha=len(alphas)
    ea=zeros(len(OLEs))
    i=0
    for ole in range(max(OLEs)+1):
        if ole==OLEs[i]: # assures the corresponding difference of Wm
            absdw=abs(Wm[-1,:]) # very last updated weights
            meanabsdw = mean(abs(Wm[0:Wm.shape[0]-1,:]),0)
            Nalpha = 0
            for alpha in alphas:
                Nalpha += sum(absdw>alpha*meanabsdw)
            ea[i] = float(Nalpha)/(nw*nalpha)
            i+=1
        Wm = Wm[1:,:]-Wm[0:(shape(Wm)[0]-1),:] #difference Wm
    return(ea)
#====================================================

class MyFrame1(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame1.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, "\nLEARNING ENTROPY\ndemo for time series", style=wx.ALIGN_CENTRE)
        with open ("readme.txt", "r") as myfile:
            readmetext=myfile.read()
        self.text_ctrl_3 = wx.TextCtrl(self, -1, readmetext,style=wx.TE_MULTILINE | wx.TE_LINEWRAP | wx.TE_WORDWRAP)
        self.text_ctrl_1 = wx.TextCtrl(self, -1, "# create your time series (with perturbation)\n# y=loadtxt('ecg.txt')[9000:13000]\nt=arange(0,600,1.7)\nomega=2*pi/10\ny=10*sin(omega*t)+30 \n# y...the evaluated time series\ny[len(y)/2]+=0.001  # perturbation in the middle", style=wx.TE_PROCESS_ENTER | wx.TE_PROCESS_TAB | wx.TE_MULTILINE)
        self.button_3 = wx.Button(self, -1, "find and load y from .txt")
        self.button_1 = wx.Button(self, -1, "<== run script for your time series y", style=wx.BU_LEFT)
        self.text_ctrl_2 = wx.TextCtrl(self, -1, "# neural predictor setup\nn1=5            # number of hidden neurons in single-hidden layer MLP \nn=3               # input vector length, x(k)=[1 y(k) y(k-1) ... y(k-n+1)] [samples]\np=1                   # prediction horizon yn(k+p)=f(w,x(k)) [samples]\nNtrain=20              # pre-training on first Ntrain samples\nepochs=3               # epochs of pre-training \nmu=0.5                       # learning rate", style=wx.TE_PROCESS_ENTER | wx.TE_PROCESS_TAB | wx.TE_MULTILINE)
        self.radio_box_1 = wx.RadioBox(self, -1, "Learning System", choices=["Static LNU", "Static QNU", "Static MLP"], majorDimension=3, style=wx.RA_SPECIFY_COLS)
        self.radio_box_2 = wx.RadioBox(self, -1, "Learning Algorithm", choices=["Gradient Descent", "Gradient Descent with normalized learning rate"], majorDimension=0, style=wx.RA_SPECIFY_ROWS)
        self.text_ctrl_4 = wx.TextCtrl(self, -1, "# Learning Entropy (AISLE) setup\nm=30                                              # length of weight history\nalphas=array((100,50,30,10,5))       # detection sensitivities\nOLEs=array((1,4))                              # Orders of Learning Entropy (known as resonable for 1...4)", style=wx.TE_PROCESS_ENTER | wx.TE_PROCESS_TAB | wx.TE_MULTILINE)
        self.button_2 = wx.Button(self, -1, "RUN setup scripts + LE")
        self.button_4 = wx.Button(self, -1, "separate figure")
 #---
        self.figure_big = Figure()
        self.figure_big_axes1 = self.figure_big.add_subplot(411) # y,yn
        self.figure_big_axes2 = self.figure_big.add_subplot(412) # e
        self.figure_big_axes3 = self.figure_big.add_subplot(413) # LEs
        self.figure_big_axes4 = self.figure_big.add_subplot(414) # LEPs        
        self.big_figure = FigureCanvas(self, -1, self.figure_big) # custom widget
   #---custom widget as a toolbar for big figure
        self.fig_toolbar = NavigationToolbar2Wx(self.big_figure) # custom widget  
##        self.big_figure = CustomWidget(self, wx.ID_ANY)
##        self.fig_toolbar = CustomWidget(self, wx.ID_ANY)
##        self.big_figure = CustomWidget(self, -1)
##        self.fig_toolbar = CustomWidget(self, -1)

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.find_and_load, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.run_script, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.Run_LE, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.separate_figure, self.button_4)
        
        self.yn=[]  # if y not yet loaded
        self.y=[]
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame1.__set_properties
        self.SetTitle("frame_1")
        self.label_1.SetMinSize((200, 85))
        self.label_1.SetBackgroundColour(wx.Colour(255, 255, 255))
        self.label_1.SetForegroundColour(wx.Colour(0, 0, 255))
        self.label_1.SetFont(wx.Font(12, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "MS Shell Dlg 2"))
        self.text_ctrl_3.SetMinSize((200, 275))
        self.text_ctrl_1.SetMinSize((600, 120))
        self.text_ctrl_1.SetBackgroundColour(wx.Colour(247, 249, 233))
        self.text_ctrl_1.SetForegroundColour(wx.Colour(51, 51, 207))
        self.text_ctrl_1.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "MS Shell Dlg 2"))
        self.button_3.SetMinSize((200, 33))
        self.button_3.SetBackgroundColour(wx.Colour(247, 249, 233))
        self.button_3.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "MS Shell Dlg 2"))
        self.button_1.SetMinSize((270, 40))
        self.button_1.SetBackgroundColour(wx.Colour(247, 249, 233))
        self.button_1.SetForegroundColour(wx.Colour(51, 51, 207))
        self.button_1.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "MS Shell Dlg 2"))
        self.text_ctrl_2.SetMinSize((600, 130))
        self.text_ctrl_2.SetBackgroundColour(wx.Colour(223, 255, 228))
        self.text_ctrl_2.SetForegroundColour(wx.Colour(0, 0, 255))
        self.text_ctrl_2.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "MS Shell Dlg 2"))
        self.radio_box_1.SetMinSize((300, 50))
        self.radio_box_1.SetBackgroundColour(wx.Colour(235, 241, 231))
        self.radio_box_1.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "MS Shell Dlg 2"))
        self.radio_box_1.SetSelection(0)
        self.radio_box_2.SetMinSize((300, 60))
        self.radio_box_2.SetBackgroundColour(wx.Colour(225, 225, 225))
        self.radio_box_2.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "MS Shell Dlg 2"))
        self.radio_box_2.SetSelection(0)
        self.text_ctrl_4.SetMinSize((600, 80))
        self.text_ctrl_4.SetBackgroundColour(wx.Colour(223, 255, 228))
        self.text_ctrl_4.SetForegroundColour(wx.Colour(255, 0, 0))
        self.text_ctrl_4.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "MS Shell Dlg 2"))
        self.button_2.SetMinSize((300, 63))
        self.button_2.SetBackgroundColour(wx.Colour(223, 255, 228))
        self.button_2.SetFont(wx.Font(14, wx.MODERN, wx.NORMAL, wx.BOLD, 0, ""))
        self.button_4.SetMinSize((200, 33))
        self.button_4.SetBackgroundColour(wx.Colour(223, 255, 228))
        self.button_4.SetFont(wx.Font(14, wx.MODERN, wx.NORMAL, wx.BOLD, 0, ""))
        self.big_figure.SetMinSize((1150,500))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame1.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        grid_sizer_1 = wx.FlexGridSizer(2, 1, 3, 3)
        grid_sizer_2 = wx.FlexGridSizer(3, 1, 2, 2)
        grid_sizer_4 = wx.FlexGridSizer(1, 2, 2, 2)
        grid_sizer_5 = wx.FlexGridSizer(3, 2, 10, 2)
        grid_sizer_8 = wx.FlexGridSizer(2, 1, 2, 2)
        grid_sizer_7 = wx.FlexGridSizer(2, 1, 5, 2)
        grid_sizer_9 = wx.FlexGridSizer(2, 1, 3, 3)
        grid_sizer_9.Add(self.label_1, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        grid_sizer_9.Add(self.text_ctrl_3, 0, 0, 0)
        grid_sizer_4.Add(grid_sizer_9, 1, wx.EXPAND, 0)
        grid_sizer_5.Add(self.text_ctrl_1, 0, 0, 0)
        grid_sizer_7.Add(self.button_3, 0, wx.LEFT | wx.TOP | wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_CENTER_VERTICAL, 25)
        grid_sizer_7.Add(self.button_1, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 25)
        grid_sizer_5.Add(grid_sizer_7, 1, 0, 0)
        grid_sizer_5.Add(self.text_ctrl_2, 0, wx.TOP, 5)
        grid_sizer_8.Add(self.radio_box_1, 0, wx.TOP, 5)
        grid_sizer_8.Add(self.radio_box_2, 0, wx.TOP, 2)
        grid_sizer_5.Add(grid_sizer_8, 1, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 25)
        grid_sizer_5.Add(self.text_ctrl_4, 0, wx.TOP, 5)
        grid_sizer_5.Add(self.button_2, 0, wx.LEFT | wx.ALIGN_BOTTOM, 25)
        grid_sizer_4.Add(grid_sizer_5, 1, wx.LEFT | wx.EXPAND | wx.SHAPED, 5)
        grid_sizer_1.Add(grid_sizer_4, 1, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 5)
        grid_sizer_2.Add(self.big_figure, 1, wx.EXPAND, 0)
        grid_sizer_2.Add(self.fig_toolbar, 1, wx.TOP | wx.EXPAND, 1)
        grid_sizer_2.Add(self.button_4, 0, wx.LEFT | wx.ALIGN_BOTTOM, 1)
        grid_sizer_1.Add(grid_sizer_2, 1, wx.LEFT | wx.TOP | wx.EXPAND, 5)
        sizer_1.Add(grid_sizer_1, 1, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 5)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    def find_and_load(self, event):  # wxGlade: MyFrame1.<event_handler>
        a=easygui.fileopenbox()        
        self.y=loadtxt(a)
        self.figure_big_axes1.cla()
        self.figure_big_axes1.plot(self.y)
        self.figure_big_axes1.grid()
        self.figure_big_axes1.set_title('yreal',fontsize=10)
        self.figure_big_axes2.cla()
        self.figure_big_axes3.cla()
        self.figure_big_axes4.cla()
        self.big_figure.draw()
        event.Skip()

    def run_script(self, event):  # wxGlade: MyFrame1.<event_handler>
        y=self.y
        exec(self.text_ctrl_1.GetValue())
        self.y=y
        self.figure_big_axes1.cla()
        self.figure_big_axes1.plot(self.y)
        self.figure_big_axes1.grid()
        self.figure_big_axes1.set_title('yreal',fontsize=10)
        self.figure_big_axes2.cla()
        self.figure_big_axes3.cla()
        self.figure_big_axes4.cla()
        self.big_figure.draw()
        event.Skip()
        
    def phi(self,nu):
        bz=2/(1.+exp(-nu))-1
        return(bz)
    
    def dphidnu(self,nu):
        bzz=2*exp(-nu)/(1.+exp(-nu))**2
        return(bzz)
    
    def Run_LE(self, event):  # wxGlade: MyFrame1.<event_handler>
        if self.y==[]:   # if y not loaded yet
            exec(self.text_ctrl_1.GetValue())
            self.y=y
        exec(self.text_ctrl_2.GetValue())
        exec(self.text_ctrl_4.GetValue())
        self.figure_big_axes1.cla()
        self.figure_big_axes1.plot(self.y)
        self.figure_big_axes1.plot((Ntrain-1,Ntrain-1),(npmin(self.y),npmax(self.y)),'--k',linewidth=2) # end of pre-training interval
        self.figure_big_axes1.grid()
        self.figure_big_axes1.set_title('yreal',fontsize=10)
        self.figure_big_axes2.cla()
        self.figure_big_axes3.cla()
        self.figure_big_axes4.cla()
        self.big_figure.draw()        
        mLE=m
        ny=n
        OLEs=OLEs.reshape(-1)  # for singletons
        meany=mean(self.y)
        stdy=std(self.y)
        y=(self.y-meany)/3./stdy
        #---inits----
        N=len(self.y)
        e=zeros(N)
        yn=zeros(N)
        yn[:ny+1]=y[:ny+1]
        nx=1+ny
        if self.radio_box_1.GetSelection()==0: #Static LNU
            nw=nx
            w=random.randn(nw)/nw
        if self.radio_box_1.GetSelection()==1: #Static QNU
            nw=(nx*nx+nx)/2
            w=random.randn(nw)/nw
            colx=ones(nw)
        if self.radio_box_1.GetSelection()==2: #Static MLP
            nW=n1*nx
            nv=n1
            W=random.randn(n1,nx)/nW
            v=random.randn(1,n1)/nv
            nw=nW+nv
            w=zeros(nw)  # all weights of MLP for LE
        x=ones(nx)  
        self.EA=zeros((N,len(OLEs)))
        self.EAP=zeros((N,len(OLEs))) # Learning Entropy Profile
        nalpha=len(alphas) # number of alphas
        Wm=zeros((mLE,nw))
        abs_dwOLE = zeros((len(OLEs),nw))       
        #--LE pre-train
        for epoch in range(epochs):
            for k in range(ny,Ntrain-p+1):
                x[1:] = y[k-ny:k]
                if self.radio_box_1.GetSelection()==0: #Static LNU
                    dydw=x
                    yn[k+p-1]=dot(w,x) #y[k]
                    e[k+p-1]=y[k+p-1]-yn[k+p-1]
                    if self.radio_box_2.GetSelection()==0: #GD
                        dw=mu*e[k+p-1]*dydw
                    if self.radio_box_2.GetSelection()==1: #NGD
                        dw=mu/(1+sum(x**2))*e[k+p-1]*dydw
                    w=w+dw
                if self.radio_box_1.GetSelection()==1: #Static QNU
                    pom = 0
                    for i in range(nx):
                        for j in range(i,nx):
                            colx[pom] = x[i]*x[j]
                            pom += 1
                    dydw=colx
                    yn[k+p-1]=dot(w,colx) #y[k]
                    e[k+p-1]=y[k+p-1]-yn[k+p-1]
                    if self.radio_box_2.GetSelection()==0: #GD
                        dw=mu*e[k+p-1]*dydw
                    if self.radio_box_2.GetSelection()==1: #NGD
                        dw=mu/(1+sum(colx**2))*e[k+p-1]*dydw
                    w=w+dw
            #---- static MLP
                if self.radio_box_1.GetSelection()==2: #Static MLP
                    nu=dot(W,x)
                    x1=self.phi(nu) # 1st layer output
                    yn[k+p-1]=sum(v*x1)
                    e[k+p-1]=y[k+p-1]-yn[k+p-1]
         # hidden layer updates
                    for i in range(n1):
                        dyndWi=v[0,i]*self.dphidnu(nu[i])*x
                        if self.radio_box_2.GetSelection()==0: #GD
                            dWi=mu*e[k+p-1]*dyndWi
                        if self.radio_box_2.GetSelection()==1: #NGD
                            dWi=mu/(1+sum(x**2))*e[k+p-1]*dyndWi
                        W[i,:]=W[i,:]+dWi
         # output layer updates
                    dyndv=x1
                    if self.radio_box_2.GetSelection()==0: #GD
                        dv=mu*e[k+p-1]*dyndv
                    if self.radio_box_2.GetSelection()==1: #NGD
                        dv=mu/(1+sum(x1**2))*e[k+p-1]*dyndv                    
                    v=v+dv
                    pom=0
                    for i in range(n1):
                        for j in range(nx):
                            w[pom]=W[i,j]
                            pom += 1
                    for i in range(n1):
                        w[pom+i]=v[0,i]
        #---------------------------
                Wm[0:mLE-1,:] = Wm[1:,:]
                Wm[-1,:] = w
        #-Online run-
        yall=zeros(N)
        wall=zeros((N,nw))
        for k in range(ny,N-p+1):
            x[1:] = y[k-ny:k]
            if self.radio_box_1.GetSelection()==0: #Static LNU
                dydw=x
                yn[k+p-1]=dot(w,x) #y[k]
                e[k+p-1]=y[k+p-1]-yn[k+p-1]
                if self.radio_box_2.GetSelection()==0: #GD
                    dw=mu*e[k+p-1]*dydw
                if self.radio_box_2.GetSelection()==1: #NGD
                    dw=mu/(1+sum(x**2))*e[k+p-1]*dydw
                w=w+dw
            if self.radio_box_1.GetSelection()==1: #Static QNU
                pom = 0
                for i in range(nx):
                    for j in range(i,nx):
                        colx[pom] = x[i]*x[j]
                        pom += 1
                dydw=colx
                yn[k+p-1]=dot(w,colx) #y[k]
                e[k+p-1]=y[k+p-1]-yn[k+p-1]
                if self.radio_box_2.GetSelection()==0: #GD
                    dw=mu*e[k+p-1]*dydw
                if self.radio_box_2.GetSelection()==1: #NGD
                    dw=mu/(1+sum(colx**2))*e[k+p-1]*dydw
                w=w+dw
            if self.radio_box_1.GetSelection()==2: #Static MLP
                nu=dot(W,x)
                x1=self.phi(nu) # 1st layer output
                yn[k+p-1]=sum(v*x1)
                e[k+p-1]=y[k+p-1]-yn[k+p-1]
     # hidden layer updates
                for i in range(n1):
                    dyndWi=v[0,i]*self.dphidnu(nu[i])*x
                    if self.radio_box_2.GetSelection()==0: #GD
                        dWi=mu*e[k+p-1]*dyndWi
                    if self.radio_box_2.GetSelection()==1: #NGD
                        dWi=mu/(1+sum(x**2))*e[k+p-1]*dyndWi
                    W[i,:]=W[i,:]+dWi
     # output layer updates
                dyndv=x1
                if self.radio_box_2.GetSelection()==0: #GD
                    dv=mu*e[k+p-1]*dyndv
                if self.radio_box_2.GetSelection()==1: #NGD
                    dv=mu/(1+sum(x1**2))*e[k+p-1]*dyndv                    
                v=v+dv
                pom=0
                for i in range(n1):
                    for j in range(nx):
                        w[pom]=W[i,j]
                        pom += 1
                for i in range(n1):
                    w[pom+i]=v[0,i]
            wall[k,:]=w
            Wm[0:mLE-1,:] = Wm[1:,:]        # LE
            Wm[-1,:] = w                    # LE
            if k>=Ntrain:
                self.EA[k+p-1,:]=fcnEA(Wm,alphas,OLEs)   # LE
                self.EAP[k+p-1,:]=self.EAP[k+p-2,:]+self.EA[k+p-1,:]
                    
        self.figure_big_axes1.plot(yn*3*stdy+meany)  # y
        self.figure_big_axes1.set_title('yreal (blue),    yneural (green),    '+self.radio_box_1.GetStringSelection()+',   '+ self.radio_box_2.GetStringSelection()+',   n='+str(n)+', p='+str(p)+', Ntrain='+str(Ntrain)+', mu='+str(mu)+', epochs='+str(epochs),fontsize=10)
        
        self.figure_big_axes2.cla()
        self.figure_big_axes2.plot(e*3*stdy,'r')
        self.figure_big_axes2.plot((Ntrain-1,Ntrain-1),(npmin(e*3*stdy),npmax(e*3*stdy)),'--k',linewidth=2) # end of pre-training interval
        self.figure_big_axes2.grid()
        self.figure_big_axes2.set_title('e=yreal-yneural,                                 MAE='+str(mean(abs(e))),fontsize=10)

        self.figure_big_axes3.cla()
        self.figure_big_axes3.plot(self.EA) # Learning Entropy
        self.figure_big_axes3.plot((Ntrain-1,Ntrain-1),(0,npmax(self.EA)),'--k',linewidth=2)  # end of pre-training interval
        self.figure_big_axes3.grid()
        self.figure_big_axes3.set_title('Learning Entropy (AISLE),                     OLEs='+str(OLEs) +',  m='+str(m),fontsize=10)

        self.figure_big_axes4.cla()
        self.figure_big_axes4.plot(self.EAP) # Learning Entropy Profile
        self.figure_big_axes4.plot((Ntrain-1,Ntrain-1),(0,npmax(self.EAP)),'--k',linewidth=2)  # end of pre-training interval
        self.figure_big_axes4.grid()
        self.figure_big_axes4.set_title('Learning Entropy Profile,                     OLEs='+str(OLEs) +',  m='+str(m),fontsize=10)
        
        self.big_figure.draw()
        self.e=e
        self.Ntrain=Ntrain
        self.y=y*3*stdy+meany
        self.yn=yn*3*stdy+meany
        self.stdy=stdy
        self.meany=meany
        self.mu=mu
        self.n=n
        self.p=p
        self.epochs=epochs
        self.m=m
        self.OLEs=OLEs
        event.Skip()

    def separate_figure(self,event):
        e=self.e
        Ntrain=self.Ntrain
        y=self.y
        yn=self.yn
        stdy=self.stdy
        meany=self.meany
        mu=self.mu
        n=self.n
        p=self.p
        epochs=self.epochs
        OLEs=self.OLEs
        m=self.m
    
        figure()
        subplot(411)
        plot(y,'b')  # yreal
        plot(yn,'g')  # yneural
        plot((Ntrain-1,Ntrain-1),(npmin((y,yn)),npmax((y,yn))),'--k',linewidth=2) # end of pre-training interval
        grid()
        title('yreal (blue),    yneural (green),    '+self.radio_box_1.GetStringSelection()+',   '+ self.radio_box_2.GetStringSelection()+',   n='+str(n)+', p='+str(p)+', Ntrain='+str(Ntrain)+', mu='+str(mu)+', epochs='+str(epochs),fontsize=10)
        
        subplot(412)
        plot(e,'r')
        plot((Ntrain-1,Ntrain-1),(npmin(e),npmax(e)),'--k',linewidth=2) # end of pre-training interval
        grid()
        title('e=yreal-yneural,                                 MAE='+str(mean(abs(e))),fontsize=10)

        subplot(413)
        plot(self.EA) # Learning Entropy
        plot((Ntrain-1,Ntrain-1),(0,npmax(self.EA)),'--k',linewidth=2)  # end of pre-training interval
        grid()
        title('Learning Entropy (AISLE),                     OLEs='+str(OLEs) +',  m='+str(m),fontsize=10)

        subplot(414)
        plot(self.EAP) # Learning Entropy Profile
        plot((Ntrain-1,Ntrain-1),(0,npmax(self.EAP)),'--k',linewidth=2)  # end of pre-training interval
        grid()
        title('Learning Entropy Profile,                     OLEs='+str(OLEs) +',  m='+str(m),fontsize=10)

        show()
        
        self.e=e
        self.Ntrain=Ntrain
        self.y=y
        self.yn=yn
        self.stdy=stdy
        self.meany=meany
        self.mu=mu
        self.n=n
        self.p=p
        self.epochs=epochs
        self.OLEs=OLEs
        self.mu=m
         
        event.Skip()

# end of class MyFrame1
if __name__ == "__main__":
    gettext.install("app") # replace with the appropriate catalog name
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame1(None, wx.ID_ANY, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
